# yamlsecrets

![Version: 0.1.0](https://img.shields.io/badge/Version-0.1.0-informational?style=flat-square)

Link: https://gitlab.com/jrevolt/dotnet/jrevolt.yamlsecrets

# encryption process

1. encode input string as UTF-8 bytes
1. compress encoded data
1. generate 32 random bytes as AES key
1. encrypt AES key using provided RSA public key
1. encrypt data using AES key
1. save all in single array of bytes (see format below)
1. encode all in base64

# encrypted data format
byte[] (UTF8) + deflate (optional) + base64encode

short version header as negative number

short size of next item

byte[] AES key, RSA encrypted

short size of next item

byte[] UTF8 string bytes, AES encrypted

LEGACY format does not have version header and starts with AES key length (field #2). To distinguish between these formats, version header is saved as negative number of the same size (short).

## Requirements

| Repository | Name | Version |
|------------|------|---------|
| file://./../utils | utils | * |
## Values

| Key | Type | Default | Description |
|-----|------|---------|-------------|
| deploy.image | string | `"bitnami/kubectl"` |  |
| deploy.secret.key | string | `"YAMLSECRETS_KEY"` |  |
| deploy.secret.name | string | `nil` |  |
| deploy.serviceAccount | string | `nil` |  |
| generate.image | string | `"registry.gitlab.com/jrevolt/dotnet/jrevolt.yamlsecrets.cli"` |  |
| helm.delete | string | `"before-hook-creation,hook-succeeded"` |  |
| helm.hook | string | `"post-install,post-upgrade"` |  |
| helm.weight | int | `0` |  |
| utils | object | `{}` | [See documentation of utils chart](../utils/README.md) |

----------------------------------------------
Autogenerated from chart metadata using [helm-docs v1.12.0](https://github.com/norwoodj/helm-docs/releases/v1.12.0)